unit hiMST_DragRow;                                                                             

interface
     
uses Windows, Messages, Kol, Share, Debug, hiMTStrTbl;

type
  THIMST_DragRow = class(TDebug)
   private
	 sControl: PControl;
	 rowControl: PControl;
	 dragRow: boolean;
	 stopDrag: boolean;
     Bmp:PBitmap;
     oldIndex: integer;
     newIndex: integer;
	 step: integer;
	 oldPos: integer;
	 h: integer;
     cbState: integer;
	 dragData: TData;    
     FMSTControl: IMSTControl;
     OldMessage: TOnMessage;

     function fctl3d: boolean;     
     function fwinstyle: integer;
	 procedure SetMSTControl(Value: IMSTControl); 
     procedure _OnPaint( Sender: PControl; DC: HDC );
   public
     _prop_onEndAfterStop:boolean;
     _data_index:THI_Event;
	 _event_onEscCell: THI_Event;
     _event_onEnterCell: THI_Event;
     _event_onCellSize: THI_Event;
     _event_onClientRect: THI_Event;
     _event_onVisibleCell: THI_Event;          

	 _event_onStart: THI_Event;
     _event_onDrag: THI_Event;
     _event_onDrop: THI_Event;
     _event_onEnd: THI_Event;
     _event_onStop: THI_Event;

	 constructor Create;
	 destructor Destroy; override;
	 procedure EndDrag(index: integer);
     property _prop_MSTControl: IMSTControl read FMSTControl write SetMSTControl;
     procedure _work_doStop(var _Data: TData; Index: word);
     procedure _work_doRefresh(var _Data:TData; Index:word);     
     procedure _var_Select(var _Data:TData; Index:word);
     procedure _var_Bitmap(var _Data:TData; Index:word);
     procedure _var_Handle(var _Data:TData; Index:word);
     procedure _var_Width(var _Data:TData; Index:word);
     procedure _var_Height(var _Data:TData; Index:word);
   protected
     function _OnMessage(var Msg: TMsg; var Rslt: Integer): Boolean;
  end;

implementation

constructor THIMST_DragRow.Create;
begin
  inherited;
  Bmp := NewBitmap(0,0);
  dragRow := false;
  stopDrag := false;
  oldPos := 0;
end;

destructor THIMST_DragRow.Destroy;
begin
  Bmp.Free;
  inherited;
end;

procedure THIMST_DragRow.EndDrag;
var dt: TData;
    ind:integer;
begin
  ind := ReadInteger(dt,_data_Index,-1);
  if (ind >= 0) and (ind < sControl.Count) then
   index := ind;
  Bmp.Clear;
  rowControl.Visible := false;
  rowControl.Free;
  dtNull(dt);
  dtInteger(dt, index);
  dt.ldata := @dragData;
  _prop_MSTControl.actionitm(dt, ITM_INSERT);
  sControl.LVCurItem := index;
  sControl.LVItemStateImgIdx[index] := cbState;  
  sControl.LVMakeVisible(index, false);
  dtNull(dragData);
  if stopDrag then
   begin
    _hi_onEvent(_event_onStop,index);
    if _prop_onEndAfterStop then     
      _hi_onEvent(_event_onEnd,index);
   end
  else 
   _hi_onEvent(_event_onEnd,index);
end;

function THIMST_DragRow._OnMessage;
type
  TMouseDownPt = packed record
    X: Word;
    Y: Word;
  end;

var dc:HDC;
    Pt: TMouseDownPt; 
    HTI: TLVHitTestInfo;
    b: integer;
    R: TRect;
  procedure Drag(pos: integer);
  begin
   if stopDrag then exit;
   if dragRow then
     begin
	   rowControl.Top := pos - h;
	   //_hi_onEvent(_event_onDrag);
     end
   else//noDrag
     begin
	   step := abs(oldPos - pos);
	   if step > 8 then
         begin
		   if sControl.LVSelCount > 1 then//if multiselect
		    begin
		     sControl.LVCurItem := -1;
		     sControl.LVCurItem := oldIndex;
		    end;
		   sControl.LVMakeVisible(oldIndex, false);//if scrolling fast 
		   sControl.LVItemState[oldIndex] := [lvisHighlight];
		   R := sControl.LVItemRect(oldIndex, lvipBounds);
		   h := (r.Bottom - r.Top) div 2;
		   b := 0;
    	   if fctl3d then
       		 case fwinstyle of
          	  0: b := 3;
        	  1: b := 1;
        	  2: b := 2;
        	  3: b := 4;
       		  4: b := 6;
      		  end
    	    else
     		 b := 1;
		   rowControl := NewPaintbox(sControl);
 		   rowControl.Visible := False;
  		   rowControl.OnPaint := _OnPaint;
		   rowControl.Focused := true;
		   Bmp.Width := R.Right;
           Bmp.Height := R.Bottom - R.Top;
		   dc := GetWindowDC(sControl.Handle);
       	   BitBlt(Bmp.Canvas.Handle,0,0,Bmp.Width,Bmp.Height,DC,4,R.Top + 1,SRCCOPY);  
           ReleaseDC(sControl.Handle,dc);
		   SetParent(rowControl.Handle,sControl.Handle);
		   rowControl.Visible := True;
		   rowControl.Left := b;
		   rowControl.Width := min(r.Right - b,sControl.Width - GetSystemMetrics(SM_CXVSCROLL) - b * 2 - 1); 
		   rowControl.Height := R.Bottom - R.Top;
		   dragRow := true;
       	   dtNull(dragData);
		   dragData := _prop_MSTControl.getstring(oldIndex);
           cbState := sControl.LVItemStateImgIdx[oldIndex];
  		   oldPos := pos;
	   	   ReleaseCapture;
       	   SetCapture(sControl.Handle);       	   
		    _hi_onEvent(_event_onStart, oldIndex);
	   	   sControl.LVDelete(oldIndex);
 		 end;
     end;   
   end;

  procedure Drop(y:integer);
  begin
    ReleaseCapture;
    if stopDrag then
     begin
      stopDrag := false;
      exit;
     end;
    if not dragRow then exit;
    oldPos := y;
	if y < 0 then
	  newIndex := 0
	else
	 if y > sControl.Height then
	   newIndex := sControl.Count
     else
       begin
         newIndex := sControl.LVItemAtPos(sControl.LVColWidth[0],y);
         if (newIndex = -1) then
           newIndex := sControl.Count - 1;
		 R := sControl.LVItemRect(newIndex, lvipBounds);
      	 if (R.Top + h) < y then
           newIndex := min(sControl.Count, newIndex + 1);
       end;
    dragRow := false;
    _hi_onEvent(_event_onDrop, newIndex);
    EndDrag(newIndex);
  end;
  
  function GetPositionStructure: boolean;
   begin
    Pt:= TMouseDownPt(Msg.lParam);
    HTI.pt.x := Pt.X;
    HTI.pt.y := Pt.Y;
    sControl.Perform(LVM_SUBITEMHITTEST, 0, Integer( @HTI ));
    Result := (HTI.flags <> LVHT_ONITEMSTATEICON) and (HTI.iItem <> -1)
   end;

begin
  Result := false;
  if (sControl.LVStyle = lvsDetail) or (sControl.LVStyle = lvsDetailNoHeader) then
   case Msg.message of
    WM_LBUTTONDOWN:
     begin
      if GetPositionStructure then
       begin 
        oldIndex := HTI.iItem;
        step := 0;
        oldPos := HTI.pt.y;
       end;
     end;
    WM_RBUTTONDOWN:
    
	 if dragRow then
      Drop(SmallInt(hiWord(Msg.lParam)));
    WM_LBUTTONUP:
	 Drop(SmallInt(hiWord(Msg.lParam)));
	WM_MOUSEMOVE:
     begin
   	  if sControl.Count = 1 then exit;
       case (Msg.wParam and MK_LBUTTON) of
        0: oldPos := SmallInt(hiWord(Msg.lParam));
	    1: Drag(SmallInt(hiWord(Msg.lParam)));
	   end;
	 end; 
   end;
  Result := Result or _hi_OnMessage(OldMessage, Msg, Rslt);
end;

function THIMST_DragRow.fctl3d;
begin
  if Assigned(_prop_MSTControl) then
    Result := _prop_MSTControl.getfctl3d  
  else
    Result := true;
end;

function THIMST_DragRow.fwinstyle;
begin
  if Assigned(_prop_MSTControl) then
    Result := _prop_MSTControl.getwinstyle  
  else
    Result := 0;
end;

procedure THIMST_DragRow.SetMSTControl;
begin
  if Value = nil then exit; 
  FMSTControl := Value;
  sControl := FMSTControl.ctrlpoint;
  FMSTControl.detachwndproc;
  OldMessage:= sControl.OnMessage;
  sControl.OnMessage := _OnMessage;
end;

procedure THIMST_DragRow._OnPaint;
begin
 if not Bmp.Empty then
  Bmp.Draw(DC,0,0);
end;

procedure THIMST_DragRow._work_doStop;
begin
  if not Assigned(_prop_MSTControl) then exit;
  if dragRow then
   begin
    dragRow := false;
    stopDrag := true;
    EndDrag(oldIndex);
   end;   
end;

procedure THIMST_DragRow._work_doRefresh;
begin
  rowControl.Invalidate;
end;

procedure THIMST_DragRow._var_Select;
begin
  if dragRow then
   _Data := dragData
  else
   dtNull(_Data);   
end;

procedure THIMST_DragRow._var_Bitmap;
begin
   dtBitmap(_data,Bmp);
end;

procedure THIMST_DragRow._var_Handle;
begin
 if dragRow then
  dtInteger(_data, rowControl.GetWindowHandle)
 else
  dtInteger(_data, 0);
end;

procedure THIMST_DragRow._var_Width; 
begin 
 if dragRow then
  dtInteger(_data, rowControl.Width)
 else
  dtInteger(_data, 0);
end;

procedure THIMST_DragRow._var_Height; 
begin 
 if dragRow then
  dtInteger(_data, rowControl.Height)
 else
  dtInteger(_data, 0);
end; 

end.